#include "graphics.h"

void CopySprite_Palette(const unsigned char* data, const unsigned short* palette, int x, int y, int width, int height)
{ 
   unsigned short* VRAM = (unsigned short*)VRAM_ADRESS; 
   int i,j;
   unsigned short* ptr = VRAM + y*LCD_WIDTH_PX + x; 
   for(j=0; j<height; j++) { 
		for(i = 0; i < width; i++)
		{
			*ptr = palette[*(data++)];
			ptr++;
		}
		ptr += LCD_WIDTH_PX-width;
   } 
}

void CopySpriteClippingMaskedAlpha(char* bitmap, short* palette, int x, int y, int width, int height, short mask, char alpha)
{
	short* VRAM = GetVRAMAdress();
	int x_inc = width;
	if (y < 0) {
		bitmap -= y * width;
		height += y;
		y = 0;
	}
	if (height > LCD_HEIGHT_PX - y) height = LCD_HEIGHT_PX - y;
	
	if (x < 0) {
		bitmap -= x;
		width += x;
		x = 0;
	}
	if (width > LCD_WIDTH_PX - x) width = LCD_WIDTH_PX - x;
	
	x_inc -= width;
	alpha %= 32;
	
	int y_index;
	int x_index;
	short * base = y * LCD_WIDTH_PX + x + VRAM+32;
	for (y_index = height; y_index > 0; --y_index, base += LCD_WIDTH_PX - width, bitmap += x_inc) {
		for (x_index = width; x_index > 0; --x_index, ++base, ++bitmap) {
			if (palette[*bitmap] != mask) *base = ((((palette[*bitmap] & 0xF81F) * alpha + (*base & 0xF81F) * (32-alpha)) >> 5) & 0xF81F) |
			                                      ((((palette[*bitmap] & 0x07E0) * alpha + (*base & 0x07E0) * (32-alpha)) >> 5) & 0x07E0);
		}
	}
}



void CopySprite_Palette_Alpha(const unsigned char* data, const unsigned short* palette, int x, int y, int width, int height)
{
   unsigned short* VRAM = (unsigned short*)VRAM_ADRESS;
   unsigned short* ptr = VRAM + y*LCD_WIDTH_PX + x;
   int i,j;
   for(j=0; j<height; j++) { 
		for(i = 0; i < width; i++)
		{
			if(*data)
				*ptr = palette[*(data)];
			ptr++;
			data++;
		}
		ptr += LCD_WIDTH_PX-width;
   } 
}


void Fade()
{
	int i;
	short* VRAM = GetVRAMAdress();
	for(i=LCD_WIDTH_PX*LCD_HEIGHT_PX ; i ; i--)
		*(VRAM++) = (((*VRAM & 0xF81F) >> 1) & 0xF81F) | (((*VRAM & 0x07E0) >> 1) & 0x07E0); 
}


void Print_Int(int x, int y, unsigned int number, int size, int color)
{
	char str[20]="0";
	int i, l=0;
	for(i=number ; i ; i/=10) l++;
	for(i=number ; i ; i/=10) str[--l] = i%10+'0';
	CL_text_print(x, y, &str, size, color);
}

