#include "sudoku.h"

void curseur(int x, int y, int taille, short color)
{
	x=x*13+DECALAGE_X;
	y=y*13+DECALAGE_Y;
	int t=13;
	int i=13;
	CL_Line(x, y, x, y+taille, color);
	CL_Line(x, y, x+taille, y, color);
	CL_Line(x+t, y, x+t-taille, y, color);
	CL_Line(x+t, y, x+t, y+taille, color);
	CL_Line(x, y+i, x, y+i-taille, color);
	CL_Line(x, y+i, x+taille, y+i, color);
	CL_Line(x+t, y+i, x+t-taille, y+i, color);
	CL_Line(x+t, y+i, x+t, y+i-taille, color);
}

// Fonction d'affichage
void affichage (int grille[9][9])
{
	int i, j;
	CL_text_print(128, 5 ,"Sudoku Solver", 2, COLOR_1);
	for(i=0; i<10; i++)
	{
		CL_Line(i*13+DECALAGE_X, DECALAGE_Y, i*13+DECALAGE_X, 117+DECALAGE_Y, COLOR_1+COLOR_2*((i%3)==0));
		CL_Line(DECALAGE_X, i*13+DECALAGE_Y, 117+DECALAGE_X, i*13+DECALAGE_Y, COLOR_1+COLOR_2*((i%3)==0));
	}
	for (i=0; i<9; i++)
    {
        for (j=0; j<9; j++)
        {
            	if(grille[i][j]!=0)
				{
					Print_Int(13*j+DECALAGE_X+2, 13*i+DECALAGE_Y+2, grille[i][j], 2, COLOR_1);
				}
        }
    }
}

bool absentSurLigne (int k, int grille[9][9], int i)
{
    int j;
	for (j=0; j < 9; j++)
        if (grille[i][j] == k)
            return FALSE;
    return TRUE;
}

bool absentSurColonne (int k, int grille[9][9], int j)
{
	int i;
    for (i=0; i < 9; i++)
        if (grille[i][j] == k)
            return FALSE;
    return TRUE;
}

bool absentSurBloc (int k, int grille[9][9], int i, int j)
{
    int _i = i-(i%3), _j = j-(j%3);
    for (i=_i; i < _i+3; i++)
        for (j=_j; j < _j+3; j++)
            if (grille[i][j] == k)
                return FALSE;
    return TRUE;
}

bool estValide (int grille[9][9], int position)
{
    int k;
	if (position == 9*9)
        return TRUE;

    int i = position/9, j = position%9;

    if (grille[i][j] != 0)
        return estValide(grille, position+1);

    for (k=1; k <= 9; k++)
    {
        if (absentSurLigne(k,grille,i) && absentSurColonne(k,grille,j) && absentSurBloc(k,grille,i,j))
        {
            grille[i][j] = k;

            if ( estValide (grille, position+1) )
                return TRUE;
        }
    }
    grille[i][j] = 0;

    return FALSE;
}

int main(void) {
	/*** initialisation des variables ***/
	int grille[9][9] =
    {
        {0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0},
    };//0->rien case vide
	int a, b, key=0, x=0, y=0;
	/*** entrée du grille ***/
	while(key!=K_F1)
	{
		key=GetKeyNB();
		if((y>0) && (key_down(K_UP))) y--;
		if((y<8) && (key_down(K_DOWN))) y++;
		if((x>0) && (key_down(K_LEFT))) x--;
		if((x<8) && (key_down(K_RIGHT))) x++;
		if(key==K_1) grille[y][x]=1;
		if(key==K_2) grille[y][x]=2;
		if(key==K_3) grille[y][x]=3;
		if(key==K_4) grille[y][x]=4;
		if(key==K_5) grille[y][x]=5;
		if(key==K_6) grille[y][x]=6;
		if(key==K_7) grille[y][x]=7;
		if(key==K_8) grille[y][x]=8;
		if(key==K_9) grille[y][x]=9;
		if((key==K_0) || (key==K_DEL)) grille[y][x]=0;
		if((key==K_MENU) || (key==K_EXIT)) return 0;
		CL_Filled_Rectangle(x*13+DECALAGE_X+1, y*13+DECALAGE_Y+1, x*13+DECALAGE_X+12, y*13+DECALAGE_Y+12, COLOR_4);
		affichage(grille);
		CL_text_print(148, 36 ,"Press [F1] to valid", 1, COLOR_1);
		Bdisp_PutDisp_DD();
		Bdisp_AllClr_VRAM();
		OS_InnerWait_ms(50);
	}
	CL_text_print(176, 105, "Loading", 1, COLOR_1);
	Bdisp_PutDisp_DD();
	int grille_2[9][9]={{0}};
	for(a=0; a<9; a++)for(b=0; b<9; b++) grille_2[a][b]=grille[a][b];
	/*** calcul ***/
	estValide(grille, 0);
	/*** fin ***/
	Bdisp_AllClr_VRAM();
	affichage(grille);
	for (a=0; a<9; a++)
    {
        for (b=0; b<9; b++)
        {
            	if(grille_2[a][b]!=0)
				{
					CL_Filled_Rectangle(b*13+DECALAGE_X+1, a*13+DECALAGE_Y+1, b*13+DECALAGE_X+12, a*13+DECALAGE_Y+12, COLOR_3);
					Print_Int(13*b+DECALAGE_X+2, 13*a+DECALAGE_Y+2, grille_2[a][b], 2, COLOR_1);
				}
        }
    }
	key=0;
	Bdisp_PutDisp_DD();
	while(key==0)
	{
		key=GetKeyNB();
	}
	return 0;
}

